<?php 
/*
 * Rcupre le PageRank  partir d'une URL
 *  
 * @file         pagerank.class.php

 * @author       MICHEL Sylvain
 * @version      1.0
 * @since        2005-12-04
 * @project      PFA
 * @package      PFA
 * @subpackage   I/O
 * @copyright    (C) 2005 MICHEL Sylvain webmaster@netsliver.com
 */

class PRGoogle {
	var $url;
	
	function PRGoogle( $url = '' ) {
		$this->url = strlen($url) == 0 ? $_GET['url'] : $url;
		$this->getPR($this->url);
	}
	
	function zeroFill($a, $b) { 
		$z = hexdec(80000000);
		if ($z & $a) { 
			$a = ($a >> 1); 
			$a &= (~$z); 
			$a |= 0x40000000; 
			$a = ($a >> ($b - 1)); 
		} else { 
			$a = ($a >> $b); 
		} 
		return $a; 
	} 


	function mix($a,$b,$c) { 
	  $a -= $b; $a -= $c; $a ^= ($this->zeroFill($c, 13)); 
	  $b -= $c; $b -= $a; $b ^= ($a << 8); 
	  $c -= $a; $c -= $b; $c ^= ($this->zeroFill($b, 13)); 
	  $a -= $b; $a -= $c; $a ^= ($this->zeroFill($c, 12)); 
	  $b -= $c; $b -= $a; $b ^= ($a << 16); 
	  $c -= $a; $c -= $b; $c ^= ($this->zeroFill($b, 5)); 
	  $a -= $b; $a -= $c; $a ^= ($this->zeroFill($c, 3));   
	  $b -= $c; $b -= $a; $b ^= ($a << 10); 
	  $c -= $a; $c -= $b; $c ^= ($this->zeroFill($b, 15)); 
	
	  return array($a, $b, $c); 
	} 

	function GoogleCH( $url, $length = NULL, $init = 0xE6359A60 ) { 
		if ( is_null($length) ) { 
			$length = sizeof($url); 
		} 
		$a = $b = 0x9E3779B9; 
		$c = $init; 
		$k = 0; 
		$len = $length; 
		while ( $len >= 12 ) { 
			$a += ($url[$k + 0] +($url[$k + 1] << 8) + ($url[$k + 2] << 16) + ($url[$k + 3] << 24)); 
			$b += ($url[$k + 4] +($url[$k + 5] << 8) + ($url[$k + 6] << 16) + ($url[$k + 7] << 24)); 
			$c += ($url[$k + 8] +($url[$k + 9] << 8) + ($url[$k + 10] << 16)+ ($url[$k + 11] << 24)); 
			$mix = $this->mix($a, $b, $c); 
			$a = $mix[0]; $b = $mix[1]; $c = $mix[2]; 
			$k += 12; 
			$len -= 12; 
		} 
	
		$c += $length; 
	
		switch ( $len ) {             /* all the case statements fall through */ 
			case 11: $c += ($url[$k + 10] << 24); 
			case 10: $c += ($url[$k + 9] << 16); 
			case 9 : $c += ($url[$k + 8] << 8); /* the first byte of c is reserved for the length */ 
			case 8 : $b += ($url[$k + 7] << 24); 
			case 7 : $b += ($url[$k + 6] << 16); 
			case 6 : $b += ($url[$k + 5] << 8); 
			case 5 : $b += ($url[$k + 4]); 
			case 4 : $a += ($url[$k + 3] << 24); 
			case 3 : $a += ($url[$k + 2] << 16); 
			case 2 : $a += ($url[$k + 1] << 8); 
			case 1 : $a += ($url[$k + 0]); /* case 0: nothing left to add */ 
		} 
		$mix = $this->mix($a,$b,$c); 
		return $mix[2]; 
	} 

	//converts a string into an array of integers containing the numeric value of the char 

	function strord( $string ) { 
		for ( $i = 0 ; $i < strlen($string) ; $i++ ) { 
			$result[$i] = ord($string{$i}); 
		} 
		return $result; 
	} 

	function getPR( $url ) {
		$this->url = strlen($url) == 0 ? $_GET['url'] : $url;
		header("Content-Type: text/plain; charset=utf-8"); 

		$ch = '6'.$this->GoogleCH($this->strord('info:'.$this->url)); 
		
		$fp = fsockopen('www.google.com', 80, $errno, $errstr, 30);
		if ( !$fp ) {
		   echo "$errstr ($errno)<br />\n";
		} else {
		   $out = 'GET /search?client=navclient-auto&ch='.$ch.'&features=Rank&q=info:'.$this->url.' HTTP/1.1'."\r\n";
		   $out .= 'Host: www.google.com'."\r\n";
		   $out .= 'Connection: Close'."\r\n\r\n";
		
		   fwrite($fp, $out);
		   
			while ( !feof($fp) ) {
				$data = fgets($fp, 128);
				$pos = strpos($data, 'Rank_');
				if ( $pos !== false ) {
					$pagerank = substr($data, $pos + 9);
					header ('Content-type: image/png');
					$im = @imagecreate(70, 10);
					$background_color = imagecolorallocate($im, 255, 255, 255);
					$pr_color = imagecolorallocate($im, 0, 150, 50);
					imagerectangle($im, 3, 2, 40, 6, $pr_color);
					imagefilledrectangle($im, 3, 2, ($pagerank * 8) / 2, 6, $pr_color);
					$text_color = imagecolorallocate($im, 0, 0, 0);
					imagestring($im, 1, 43, 1, substr($pagerank, 0, strlen($pagerank) - 1).'/10', $text_color);
					imagepng($im);
					imagedestroy($im);
				}
			}
			fclose($fp);
		}
		exit;
	}
}
?>