<?php
/*
 * Classe Rss
 *  
 * @file         rss.class.php
 * @author       MICHEL Sylvain
 * @version      1.0
 * @since        2005-11-25
 * @project      PFA
 * @package      PFA
 * @subpackage   I/O
 * @copyright    (C) 2005 MICHEL Sylvain webmaster@netsliver.com
 */


class Rss {
	var $itemprogress = 0;
	var $itemcount = 0;
	                       
	var $rss_channel = array();
	var $rss_channel_image = array();
	var $rss_channel_textInput = array();
	var $rss_channel_optional = array();
	var $rss_item = array(array());
	 
	var $rss_inc_channel = false;
	var $rss_inc_channel_image = false;
	var $rss_inc_channel_textInput = false;
	var $rss_inc_items = false;
	
	function createfile($filename = '') {
		$xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?".">\n";
		$xml .= "<rss version=\"2.0\">\n";
		$xml .= "\t<channel>\n";
		while ( $node = current($this->rss_channel) ) {
			$xml .= "\t\t<".key($this->rss_channel).">".$node."</".key($this->rss_channel).">\n";
			next($this->rss_channel);
		}
		if ( count($this->rss_channel_optional) > 0 ) {
			while ( $node = current($this->rss_channel_optional) ) {
				$xml .= !empty($node) ? "\t\t<".key($this->rss_channel_optional).">".$node."</".key($this->rss_channel_optional).">\n" : '';
				next($this->rss_channel_optional);
			}
		}
		if ( count($this->rss_channel_image) > 0 ) {
			$xml .= "\t\t<image>\n";
			while ( $node = current($this->rss_channel_image) ) {
				$xml .= !empty($node) ? "\t\t\t<".key($this->rss_channel_image).">".$node."</".key($this->rss_channel_image).">\n" : '';
				next($this->rss_channel_image);
			}
			$xml .= "\t\t</image>\n";
		}
		if ( count($this->rss_channel_textInput) > 0 ) {
			$xml .= "\t\t<textInput>\n";
			while ( $node = current($this->rss_channel_textInput) ) {
				$xml .= !empty($node) ? "\t\t\t<".key($this->rss_channel_textInput).">".$node."</".key($this->rss_channel_textInput).">\n" : '';
				next($this->rss_channel_textInput);
			}
			$xml .= "\t\t</textInput>\n";
		}
		for ( $i = 1 ; $i < count($this->rss_item) ; $i++ ) {
			$xml .= "\t\t<item>\n";
			while ( $node = current($this->rss_item[$i]) ) {
				$xml .= !empty($node) ? "\t\t\t<".key($this->rss_item[$i]).">".$node."</".key($this->rss_item[$i]).">\n" : '';
				next($this->rss_item[$i]);
			}
			$xml .= "\t\t</item>\n";
		}
		$xml .= "\t</channel>\n";
		$xml .= "</rss>";
		
		//criture ou affichage du fichier XML
		if ( !empty($filename) ) {
			if ( is_writable($filename) ) {
				if ( !$handle = fopen($filename, 'a') ) {
					echo "Impossible d'ouvrir le fichier ($filename)";
					exit;
				}
				if ( fwrite($handle, $xml) === FALSE ) {
					echo "Impossible d'crire dans le fichier ($filename)";
					exit;
				}
				fclose($handle);
			} else {
				echo "Le fichier $filename n'est pas accessible en criture.";
			}
		} else {
			header('content-type: application/xml');
			echo $xml;
		}
		exit;
	}
	
	function parsefile($filename, $maxitem = 1) {
		$this->itemprogress = 1;
		$lines = file($filename) or die('Le fichier <i>'.$filename.'</i> n\'est pas accessible !');
		if ( !gettype($lines) == 'array' ) return;
		
		reset($lines);
		
		while ( list($num, $line) = each($lines) ) {
			$line = trim(chop($line));
			if ( preg_match('/<channel>/', $line) ) continue;
			if ( preg_match('/<\/channel>|<image>|<item>/', $line) ) break;
						
			while ( list($num, $line) = each($lines) ) {
				$this->rss_inc_channel = true;
				$line = trim(chop($line));
				if ( empty($line) || $line[0] != '<' ) continue;
				if ( preg_match('/<\/channel>|<image>|<item>|<textInput>/', $line) ) break 2;
        			
				switch( true ) {
					case preg_match('/<title>/', $line):
						$this->rss_channel['title'] = trim(strip_tags($line));
					break;
					case preg_match('/<link>/', $line):
						$this->rss_channel['link'] = trim(strip_tags($line));
					break;
					case preg_match('/<description>/', $line):
						$this->rss_channel['description'] = trim(strip_tags($line));
					break;
					case preg_match('/<language>/', $line):
						$this->rss_channel_optional['language'] = trim(strip_tags($line));
					break;
					case preg_match('/<copyright>/', $line):
						$this->rss_channel_optional['copyright'] = trim(strip_tags($line));
					break;
					case preg_match('/<managingEditor>/', $line):
						$this->rss_channel_optional['managingEditor'] = trim(strip_tags($line));
					break;
					case preg_match('/<webMaster>/', $line):
						$this->rss_channel_optional['webMaster'] = trim(strip_tags($line));
					break;
					case preg_match('/<pubDate>/', $line):
						$this->rss_channel_optional['pubDate'] = trim(strip_tags($line));
					break;
					case preg_match('/<lastBuildDate>/', $line):
						$this->rss_channel_optional['lastBuildDate'] = trim(strip_tags($line));
					break;
					case preg_match('/<category>/', $line):
						$this->rss_channel_optional['category'] = trim(strip_tags($line));
					break;
					case preg_match('/<generator>/', $line):
						$this->rss_channel_optional['generator'] = trim(strip_tags($line));
					break;
					case preg_match('/<docs>/', $line):
						$this->rss_channel_optional['docs'] = trim(strip_tags($line));
					break;
					case preg_match('/<ttl>/', $line):
						$this->rss_channel_optional['ttl'] = trim(strip_tags($line));
					break;
					case preg_match('/<rating>/', $line):
						$this->rss_channel_optional['rating'] = trim(strip_tags($line));
					break;
					case preg_match('/<skipHours>/', $line):
						$this->rss_channel_optional['skipHours'] = trim(strip_tags($line));
					break;
					case preg_match('/<skipDays>/', $line):
						$this->rss_channel_optional['skipDays'] = trim(strip_tags($line));
					break;
				}
			}
		}
		
		reset($lines);
		 
		while ( list($num, $line) = each($lines) ) {
			$line = trim(chop($line));
			if ( preg_match('/<\/image>/', $line) ) break;
			if ( !preg_match('/<image>/', $line) ) continue;
		      
			while ( list($num, $line) = each($lines) ) {
				$this->rss_inc_channel_image = true;
				$line = trim(chop($line));
				if ( empty($line) || $line[0] != '<' ) continue;
				if ( preg_match('/<\/image>/', $line) ) break 2;
			
				switch ( true ) {
					case preg_match('/<title>/', $line):
						$this->rss_channel_image['title'] = trim(strip_tags($line));
					break;
					case preg_match('/<url>/', $line):
						$this->rss_channel_image['url'] = trim(strip_tags($line));
					break;
					case preg_match('/<link>/', $line):
						$this->rss_channel_image['link'] = trim(strip_tags($line));
					break;
					case preg_match('/<width>/', $line):
						$this->rss_channel_image['width'] = trim(strip_tags($line));
					break;
					case preg_match('/<height>/', $line):
						$this->rss_channel_image['height'] = trim(strip_tags($line));
					break;
					case preg_match('/<description>/', $line):
						$this->rss_channel_image['description'] = trim(strip_tags($line));
					break;
				}
			}
		}

		reset($lines);
		 
		while ( list($num, $line) = each($lines) ) {
			$line = trim(chop($line));
			if ( preg_match('/<\/textInput>/', $line) ) break;
			if ( !preg_match('/<textInput>/', $line) ) continue;
		      
			while ( list($num, $line) = each($lines) ) {
				$this->rss_inc_channel_textInput = true;
				$line = trim(chop($line));
				if ( empty($line) || $line[0] != '<' ) continue;
				if ( preg_match('/<\/textInput>/', $line) ) break 2;
			
				switch ( true ) {
					case preg_match('/<title>/', $line):
						$this->rss_channel_textInput['title'] = trim(strip_tags($line));
					break;
					case preg_match('/<description>/', $line):
						$this->rss_channel_textInput['description'] = trim(strip_tags($line));
					break;
					case preg_match('/<name>/', $line):
						$this->rss_channel_textInput['name'] = trim(strip_tags($line));
					break;
					case preg_match('/<link>/', $line):
						$this->rss_channel_textInput['link'] = trim(strip_tags($line));
					break;
				}
			}
		}
		
		reset ($lines); 
		
		while ( list($num, $line) = each($lines) ) {
			$line = trim(chop($line));
			if ( preg_match('/<\/rss>/', $line) ) break;
			if ( preg_match('/<\/item>/', $line) ) continue;
			if ( !preg_match('/<item>/', $line) ) continue;
		      
			if ( isset($fin) ) break;
		      
			while (list($num, $line) = each($lines)) {
				$this->rss_inc_items = true;
				$line = trim(chop($line));
				if ( empty($line) || $line[0] != '<' ) continue;
				if ( preg_match('/<\/item>/', $line) ) break;
				
				switch ( true ) {
					case preg_match('/<title>/', $line):
						$this->rss_item['title'][$this->itemprogress] = trim(strip_tags($line)); 
					break;
					case preg_match('/<link>/', $line):
						$this->rss_item['link'][$this->itemprogress] = trim(strip_tags(str_replace('<![CDATA[', '', str_replace(']]>', '', $line))));
					break;
					case preg_match('/<description>/', $line):
						$this->rss_item['description'][$this->itemprogress] = trim(strip_tags($line)); 
					break;
					case preg_match('/<author>/', $line):
						$this->rss_item['author'][$this->itemprogress] = trim(strip_tags($line)); 
					break;
					case preg_match('/<pubDate>/', $line):
						$this->rss_item['pubDate'][$this->itemprogress] = trim(strip_tags($line)); 
					break;
				}
			}
			
			$this->itemprogress++;
			if ( $this->itemprogress > $maxitem )
				$fin = true;
		}
		$this->itemcount = count($this->rss_item['title']);
	}
	
	function set_channel($title, $link, $description) {
		$this->rss_channel['title'] = utf8_encode($title);
		$this->rss_channel['link'] = utf8_encode($link);
		$this->rss_channel['description'] = utf8_encode($description);
	}
	
	function get_channel() {
		return $this->rss_channel;
	}

	function set_channel_optional($language, $copyright, $managingEditor, $webMaster, $pubDate, $lastBuildDate, $generator, $docs, $ttl, $rating, $skipHours, $skipDays) {
		$this->rss_channel_optional['language'] = utf8_encode($language);
		$this->rss_channel_optional['copyright'] = utf8_encode($copyright);
		$this->rss_channel_optional['managingEditor'] = utf8_encode($managingEditor);
		$this->rss_channel_optional['webMaster'] = utf8_encode($webMaster);
		$this->rss_channel_optional['pubDate'] = utf8_encode($pubDate);
		$this->rss_channel_optional['lastBuildDate'] = utf8_encode($lastBuildDate);
		$this->rss_channel_optional['generator'] = utf8_encode($generator);
		$this->rss_channel_optional['docs'] = utf8_encode($docs);
		$this->rss_channel_optional['ttl'] = utf8_encode($ttl);
		$this->rss_channel_optional['rating'] = utf8_encode($rating);
		$this->rss_channel_optional['skipHours'] = utf8_encode($skipHours);
		$this->rss_channel_optional['skipDays'] = utf8_encode($skipDays);
	}

	function get_channel_optional() {
		return $this->rss_channel_optional;
	}

	function set_channel_image($title, $url, $link, $width = '', $height = '', $description = '') {
		$this->rss_channel_image['title'] = utf8_encode($title);
		$this->rss_channel_image['url'] = utf8_encode($url);
		$this->rss_channel_image['link'] = utf8_encode($link);
		$this->rss_channel_image['width'] = utf8_encode($width);
		$this->rss_channel_image['height'] = utf8_encode($height);
		$this->rss_channel_image['description'] = utf8_encode($description);
	}
	
	function get_channel_image() {
		if(empty($this->rss_channel_image['width'])) $this->rss_channel_image['width'] = '88';
		if(empty($this->rss_channel_image['height'])) $this->rss_channel_image['height'] = '31';
		return $this->rss_channel_image;
	}

	function set_channel_textInput($title, $description, $name, $link) {
		$this->rss_channel_textInput['title'] = utf8_encode($title);
		$this->rss_channel_textInput['description'] = utf8_encode($description);
		$this->rss_channel_textInput['name'] = utf8_encode($name);
		$this->rss_channel_textInput['link'] = utf8_encode($link);
	}

	function get_channel_textInput() {
		return $this->rss_channel_textInput;
	}

	function add_item($title, $link, $description, $author = '', $pubDate = '') {
		$this->itemprogress++;
		$this->rss_item[$this->itemprogress]['title'] = utf8_encode(str_replace('&', '&amp;', $title));
		$this->rss_item[$this->itemprogress]['link'] = utf8_encode(str_replace('&', '&amp;', $link));
		$this->rss_item[$this->itemprogress]['description'] = utf8_encode(str_replace('&', '&amp;', $description));
		$this->rss_item[$this->itemprogress]['author'] = utf8_encode(str_replace('&', '&amp;', $author));
		$this->rss_item[$this->itemprogress]['pubDate'] = utf8_encode(str_replace('&', '&amp;', $pubDate));
	}
	
	function get_items() {
		return $this->rss_item;
	}
	
	function get_num_items() {
		return $this->itemcount;
	}
}
?>