#
# Structure de la table admin
#

CREATE TABLE pfa_admin (
  a_id int(11) unsigned NOT NULL auto_increment,
  a_login varchar(20) NOT NULL default '',
  a_password varchar(32) NOT NULL default '',
  a_mail varchar(255) NOT NULL default '',
  a_all_rights tinyint(1) NOT NULL default '0',
  a_add_admin tinyint(1) NOT NULL default '0',
  a_edit_admin tinyint(1) NOT NULL default '0',
  a_del_admin tinyint(1) NOT NULL default '0',
  a_add_mod tinyint(1) NOT NULL default '0',
  a_edit_mod tinyint(1) NOT NULL default '0',
  a_edit_title tinyint(1) NOT NULL default '0',
  a_edit_desc tinyint(1) NOT NULL default '0',
  a_edit_keywords tinyint(1) NOT NULL default '0',
  a_edit_content tinyint(1) NOT NULL default '0',
  a_del_mod tinyint(1) NOT NULL default '0',
  a_add_menu tinyint(1) NOT NULL default '0',
  a_edit_menu tinyint(1) NOT NULL default '0',
  a_del_menu tinyint(1) NOT NULL default '0',
  a_newsletter tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (a_id),
  UNIQUE KEY adm_login (a_login)
);

# --------------------------------------------------------

#
# Structure de la table heading
#

CREATE TABLE pfa_heading (
  h_id int(11) unsigned NOT NULL auto_increment,
  h_mod varchar(255) NOT NULL default '',
  h_title varchar(255) NOT NULL default '',
  h_desc varchar(255) NOT NULL default '',
  h_keywords varchar(255) NOT NULL default '',
  h_folder varchar(255) NOT NULL default '',
  h_lg char(3) NOT NULL default '',
  h_parent int(11) unsigned NOT NULL default '0',
  h_type tinyint(4) NOT NULL default '0',
  h_home tinyint(1) NOT NULL default '0',
  h_tb_news varchar(255) NOT NULL default '',
  h_tb_cat varchar(255) NOT NULL default '',
  h_tb_links varchar(255) NOT NULL default '',
  h_tb_txt varchar(255) NOT NULL default '',
  h_approved tinyint(1) NOT NULL default '0',
  h_rss int(2) NOT NULL default '0',
  h_design_date int(14) default NULL,
  PRIMARY KEY  (h_id),
  UNIQUE KEY h_mod (h_mod)
);

# --------------------------------------------------------

#
# Structure de la table adm_access
#

CREATE TABLE pfa_adm_access (
  a_id int(11) unsigned NOT NULL,
  h_id int(11) unsigned NOT NULL,
  PRIMARY KEY  (a_id, h_id)
);

# --------------------------------------------------------

#
# Structure de la table menu
#

CREATE TABLE pfa_menu (
  m_id int(11) unsigned NOT NULL auto_increment,
  m_item varchar(255) NOT NULL default '',
  m_lg char(3) NOT NULL default '',
  m_url varchar(255) NOT NULL default '',
  h_mod varchar(255) NOT NULL default '',
  m_parent int(11) NOT NULL default '0',
  m_row tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (m_id)
);

# --------------------------------------------------------

#
# Structure de la table newsletter
#

CREATE TABLE pfa_newsletter (
  n_id int(11) unsigned NOT NULL auto_increment,
  n_mail varchar(255) NOT NULL default '',
  PRIMARY KEY  (n_id),
  UNIQUE KEY n_mail (n_mail)
);