########## DIRECTORY ##########

CREATE TABLE dirfr_cat(
dc_id int(11) unsigned NOT NULL auto_increment,
dc_name varchar(100) NOT NULL default '',
dc_parent int(11) NOT NULL default '0',
dc_row tinyint(4) NOT NULL default '0',
PRIMARY KEY  (dc_id)
);

CREATE TABLE diren_cat(
dc_id int(11) unsigned NOT NULL auto_increment,
dc_name varchar(100) NOT NULL default '',
dc_parent int(11) NOT NULL default '0',
dc_row tinyint(4) NOT NULL default '0',
PRIMARY KEY  (dc_id)
);

INSERT INTO dirfr_cat (dc_id, dc_name, dc_parent)
SELECT CatID, CatNamefr, CatParent
FROM categories;

INSERT INTO diren_cat (dc_id, dc_name, dc_parent)
SELECT CatID, CatNameen, CatParent
FROM categories;

CREATE TABLE dirfr_links (
dl_id int(11) unsigned NOT NULL auto_increment,
dl_catid int(11) NOT NULL default '0',
dl_url varchar(255) NOT NULL default '',
dl_title varchar(255) NOT NULL default '',
dl_description varchar(255) NOT NULL default '',
dl_keywords varchar(255) NOT NULL default '',
dl_author varchar(100) NOT NULL default '',
dl_mail varchar(255) NOT NULL default '',
dl_company varchar(255) default '',
dl_subdate int(14) default NULL,
dl_approved int(1) NOT NULL default '0',
dl_hits int(10) NOT NULL default '0',
dl_language varchar(3) NOT NULL default '',
dl_totalvote int(10) NOT NULL default '0',
dl_nbvote int(10) NOT NULL default '0',
dl_note float NOT NULL default '0',
PRIMARY KEY  (dl_id),
UNIQUE KEY dl_url (dl_url));

INSERT INTO dirfr_links
SELECT LinkID, CatID, Url, LinkName, Description, keywords, SubmitName, SubmitEmail, SubmitSociete, UNIX_TIMESTAMP(SubmitDate), Accepter, hits, language, TotalVote, NbVote, Note
FROM links;

CREATE TABLE dirfr_linksupd (
dl_id int(11) unsigned NOT NULL auto_increment,
dl_catid int(11) NOT NULL default '0',
dl_url varchar(255) NOT NULL default '',
dl_title varchar(255) NOT NULL default '',
dl_description varchar(255) NOT NULL default '',
dl_keywords varchar(255) NOT NULL default '',
dl_author varchar(100) NOT NULL default '',
dl_mail varchar(255) NOT NULL default '',
dl_company varchar(255) default '',
dl_language varchar(3) NOT NULL default '',
PRIMARY KEY  (dl_id),
UNIQUE KEY dl_url (dl_url));

INSERT INTO dirfr_linksupd
SELECT LinkID, CatID, Url, LinkName, Description, keywords, SubmitName, SubmitEmail, SubmitSociete, language
FROM updlinks;

CREATE TABLE dirfr_txt (
t_id int(11) unsigned NOT NULL auto_increment,
t_idtb varchar(32) NOT NULL default '',
t_author varchar(100) NOT NULL default '',
t_mail varchar(255) default '',
t_homepage varchar(255) default '',
t_txt text,
t_subdate int(14) default NULL,
PRIMARY KEY  (t_id));

INSERT INTO dirfr_txt
SELECT ComID, IDTable, ComAuteur, MailAuteur, HomeAuteur, ComText, UNIX_TIMESTAMP(SubmitDate)
FROM comments
WHERE ForTable = 'links';

########## NEWS ##########

CREATE TABLE newsfr_news (
n_id int(11) unsigned NOT NULL auto_increment,
n_author varchar(100) NOT NULL default '',
n_mail varchar(255) default '',
n_title varchar(255) NOT NULL default '',
n_txt text,
n_subdate int(14) default NULL,
n_hits int(10) NOT NULL default '0',
PRIMARY KEY  (n_id));

CREATE TABLE newsen_news (
n_id int(11) unsigned NOT NULL auto_increment,
n_author varchar(100) NOT NULL default '',
n_mail varchar(255) default '',
n_title varchar(255) NOT NULL default '',
n_txt text,
n_subdate int(14) default NULL,
n_hits int(10) NOT NULL default '0',
PRIMARY KEY  (n_id));

INSERT INTO newsfr_news (n_id, n_author, n_mail, n_title, n_txt, n_subdate)
SELECT NewsID, NewsAuteur, MailAuteur, NewsTitre, NewsText, UNIX_TIMESTAMP(SubmitDate)
FROM news
WHERE language = 'fr';

INSERT INTO newsen_news (n_id, n_author, n_mail, n_title, n_txt, n_subdate)
SELECT NewsID, NewsAuteur, MailAuteur, NewsTitre, NewsText, UNIX_TIMESTAMP(SubmitDate)
FROM news
WHERE language = 'en';

CREATE TABLE newsfr_txt (
t_id int(11) unsigned NOT NULL auto_increment,
t_idtb varchar(32) NOT NULL default '',
t_author varchar(100) NOT NULL default '',
t_mail varchar(255) default '',
t_homepage varchar(255) default '',
t_txt text,
t_subdate int(14) default NULL,
PRIMARY KEY  (t_id));

INSERT INTO newsfr_txt
SELECT ComID, IDTable, ComAuteur, MailAuteur, HomeAuteur, ComText, UNIX_TIMESTAMP(SubmitDate)
FROM comments
WHERE ForTable = 'news';

CREATE TABLE newsen_txt (
t_id int(11) unsigned NOT NULL auto_increment,
t_idtb varchar(32) NOT NULL default '',
t_author varchar(100) NOT NULL default '',
t_mail varchar(255) default '',
t_homepage varchar(255) default '',
t_txt text,
t_subdate int(14) default NULL,
PRIMARY KEY  (t_id));

INSERT INTO newsen_txt
SELECT *
FROM newsfr_txt;

########## GUESTBOOK ##########

CREATE TABLE guestbook_txt (
t_id int(11) unsigned NOT NULL auto_increment,
t_idtb varchar(32) NOT NULL default '',
t_author varchar(100) NOT NULL default '',
t_mail varchar(255) default '',
t_homepage varchar(255) default '',
t_txt text,
t_subdate int(14) default NULL,
PRIMARY KEY  (t_id));

INSERT INTO guestbook_txt (t_id, t_author, t_mail, t_homepage, t_txt, t_subdate)
SELECT BookID, BookAuteur, MailAuteur, HomeAuteur, BookText, UNIX_TIMESTAMP(SubmitDate)
FROM guestbook;

########## SUGGESTS ##########

CREATE TABLE suggests_txt (
t_id int(11) unsigned NOT NULL auto_increment,
t_idtb varchar(32) NOT NULL default '',
t_author varchar(100) NOT NULL default '',
t_mail varchar(255) default '',
t_homepage varchar(255) default '',
t_txt text,
t_subdate int(14) default NULL,
PRIMARY KEY  (t_id));

INSERT INTO suggests_txt (t_id, t_author, t_mail, t_homepage, t_txt, t_subdate)
SELECT SuggID, SuggAuteur, MailAuteur, HomeAuteur, SuggText, UNIX_TIMESTAMP(SubmitDate)
FROM suggest;

########## NEWSLETTER ##########

ALTER TABLE newsletter
CHANGE ID n_id int(11) unsigned NOT NULL auto_increment,
CHANGE UserMail n_mail varchar(255) NOT NULL default '';

ALTER TABLE newsletter DROP INDEX ID ,
ADD INDEX n_id ( n_id );

ALTER TABLE newsletter DROP INDEX UserMail,
ADD UNIQUE n_mail ( n_mail );

ALTER TABLE newsletter DROP INDEX UserMail_2;

########## PHPFULLANNU V6 ##########

#
# Structure de la table admin
#

CREATE TABLE pfa_admin (
  a_id int(11) unsigned NOT NULL auto_increment,
  a_login varchar(20) NOT NULL default '',
  a_password varchar(32) NOT NULL default '',
  a_mail varchar(255) NOT NULL default '',
  a_all_rights tinyint(1) NOT NULL default '0',
  a_add_admin tinyint(1) NOT NULL default '0',
  a_edit_admin tinyint(1) NOT NULL default '0',
  a_del_admin tinyint(1) NOT NULL default '0',
  a_add_mod tinyint(1) NOT NULL default '0',
  a_edit_mod tinyint(1) NOT NULL default '0',
  a_edit_title tinyint(1) NOT NULL default '0',
  a_edit_desc tinyint(1) NOT NULL default '0',
  a_edit_keywords tinyint(1) NOT NULL default '0',
  a_edit_content tinyint(1) NOT NULL default '0',
  a_del_mod tinyint(1) NOT NULL default '0',
  a_add_menu tinyint(1) NOT NULL default '0',
  a_edit_menu tinyint(1) NOT NULL default '0',
  a_del_menu tinyint(1) NOT NULL default '0',
  a_newsletter tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (a_id),
  UNIQUE KEY adm_login (a_login)
);

# --------------------------------------------------------

#
# Structure de la table heading
#

CREATE TABLE pfa_heading (
  h_id int(11) unsigned NOT NULL auto_increment,
  h_mod varchar(255) NOT NULL default '',
  h_title varchar(255) NOT NULL default '',
  h_desc varchar(255) NOT NULL default '',
  h_keywords varchar(255) NOT NULL default '',
  h_folder varchar(255) NOT NULL default '',
  h_lg char(3) NOT NULL default '',
  h_parent int(11) unsigned NOT NULL default '0',
  h_type tinyint(4) NOT NULL default '0',
  h_home tinyint(1) NOT NULL default '0',
  h_tb_news varchar(255) NOT NULL default '',
  h_tb_cat varchar(255) NOT NULL default '',
  h_tb_links varchar(255) NOT NULL default '',
  h_tb_txt varchar(255) NOT NULL default '',
  h_approved tinyint(1) NOT NULL default '0',
  h_rss int(2) NOT NULL default '0',
  h_design_date int(14) default NULL,
  PRIMARY KEY  (h_id),
  UNIQUE KEY h_mod (h_mod)
);

# --------------------------------------------------------

#
# Structure de la table adm_access
#

CREATE TABLE pfa_adm_access (
  a_id int(11) unsigned NOT NULL,
  h_id int(11) unsigned NOT NULL,
  PRIMARY KEY  (a_id, h_id)
);

# --------------------------------------------------------

#
# Structure de la table menu
#

CREATE TABLE pfa_menu (
  m_id int(11) unsigned NOT NULL auto_increment,
  m_item varchar(255) NOT NULL default '',
  m_lg char(3) NOT NULL default '',
  m_url varchar(255) NOT NULL default '',
  h_mod varchar(255) NOT NULL default '',
  m_parent int(11) NOT NULL default '0',
  m_row tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (m_id)
);